(define-module (glicid packages monitoring)
               #:use-module (guix packages)
               #:use-module (guix utils)
               #:use-module (gnu packages)
               #:use-module (gnu packages golang)
               #:use-module ((gnu packages monitoring) #:prefix gnu:)
               #:use-module (guix download))

(define %zabbix-version "6.0.40")
(define %zabbix-hash "1b9kbckk733wqk3dr8y6zpnn2dz2k8a2nfgqmgbz0y7z712p8nh6")

(define-public zabbix-agentd
               (package 
                 (inherit gnu:zabbix-agentd)
                 (version %zabbix-version)
                 (source
                   (origin
                     (method url-fetch)
                     (uri (string-append "https://cdn.zabbix.com/zabbix/sources/stable/" (version-major+minor version) "/zabbix-" version ".tar.gz"))
                     (sha256 (base32 %zabbix-hash))
                     (modules '((guix build utils)))
                     (snippet
                       '(substitute* '("src/zabbix_proxy/proxy.c" "src/zabbix_server/server.c")
                                     (("/usr/sbin/fping6?") "/run/setuid-programs/fping")))))))


(define-public zabbix-agent2
               (package 
                 (inherit gnu:zabbix-agent2)
                 (version %zabbix-version)
                 (source
                   (origin
                     (method url-fetch)
                     (uri (string-append "https://cdn.zabbix.com/zabbix/sources/stable/" (version-major+minor version) "/zabbix-" version ".tar.gz"))
                     (sha256 (base32 %zabbix-hash))
                     (modules '((guix build utils)))
                     (snippet
                       '(substitute* '("src/zabbix_proxy/proxy.c" "src/zabbix_server/server.c")
                                     (("/usr/sbin/fping6?") "/run/setuid-programs/fping")))))))


(define-public zabbix-server
               (package 
                 (inherit gnu:zabbix-server)
                 (version %zabbix-version)
                 (source
                   (origin
                     (method url-fetch)
                     (uri (string-append "https://cdn.zabbix.com/zabbix/sources/stable/" (version-major+minor version) "/zabbix-" version ".tar.gz"))
                     (sha256 (base32 %zabbix-hash))
                     (modules '((guix build utils)))
                     (snippet
                       '(substitute* '("src/zabbix_proxy/proxy.c" "src/zabbix_server/server.c")
                                     (("/usr/sbin/fping6?") "/run/setuid-programs/fping")))))))

(define %zabbix-next-version "7.0.14")
(define %zabbix-next-hash "1zxnxp8zmbncg2lfh3blx13i3p5zcfma5cglbka5v873v7p592zy")

(define-public zabbix-next-agentd
               (package 
                 (inherit gnu:zabbix-agentd)
                 (name "zabbix-next-agentd")
                 (version %zabbix-next-version)
                 (source
                   (origin
                     (method url-fetch)
                     (uri (string-append "https://cdn.zabbix.com/zabbix/sources/stable/" (version-major+minor version) "/zabbix-" version ".tar.gz"))
                     (sha256 (base32 %zabbix-next-hash))
                     (modules '((guix build utils)))
                     (snippet
                       '(substitute* '("src/zabbix_proxy/proxy.c" "src/zabbix_server/server.c")
                                     (("/usr/sbin/fping6?") "/run/setuid-programs/fping")))))))


(define-public zabbix-next-agent2
               (package 
                 (inherit gnu:zabbix-agent2)
                 (name "zabbix-next-agent2")
                 (version %zabbix-next-version)
                 (source
                   (origin
                     (method url-fetch)
                     (uri (string-append "https://cdn.zabbix.com/zabbix/sources/stable/" (version-major+minor version) "/zabbix-" version ".tar.gz"))
                     (sha256 (base32 %zabbix-next-hash))
                     (modules '((guix build utils)))
                     (snippet
                       '(begin
                          (substitute* '("src/zabbix_proxy/proxy.c" "src/zabbix_server/server.c")
                                       (("/usr/sbin/fping6?") "/run/setuid-programs/fping"))
                          (substitute* "src/go/plugins/system/sw/sw_test.go"
                                       (("Tue Oct 18 16:34:23 2022") "Tue Oct 18 13:34:23 2022")
                                       (("Wed Nov 23 13:55:55 2022") "Wed Nov 23 11:55:55 2022")
                                       (("Thu Jun 16 23:30:12 2022") "Thu Jun 16 20:30:12 2022")
                                       (("Mon Aug  8 23:23:59 2022") "Mon Aug  8 20:23:59 2022")
                                       (("Tue Aug 10 06:12:12 2021") "Tue Aug 10 03:12:12 2021")
                                       (("Fri Sep  2 15:32:22 2022") "Fri Sep  2 12:32:22 2022"))))))
                 (native-inputs `(("go" ,go-1.23)
                                  ,@(package-native-inputs gnu:zabbix-agent2)))))


(define-public zabbix-next-server
               (package 
                 (inherit gnu:zabbix-server)
                 (name "zabbix-next-server")
                 (version %zabbix-next-version)
                 (source
                   (origin
                     (method url-fetch)
                     (uri (string-append "https://cdn.zabbix.com/zabbix/sources/stable/" (version-major+minor version) "/zabbix-" version ".tar.gz"))
                     (sha256 (base32 %zabbix-next-hash))
                     (modules '((guix build utils)))
                     (snippet
                       '(substitute* '("src/zabbix_proxy/proxy.c" "src/zabbix_server/server.c")
                                     (("/usr/sbin/fping6?") "/run/setuid-programs/fping")))))))
