(define-module (glicid system file-systems)
               #:use-module (gnu system file-systems)
               )

(define-public %cgroups
               (append (list
                         (file-system
                           (device "none")
                           (mount-point "/run/systemd")
                           (type "tmpfs")
                           (check? #f)
                           (flags '(no-suid no-dev no-exec))
                           (options "mode=0755")
                           (create-mount-point? #t)
                           )
                         (file-system
                           (device "none")
                           (mount-point "/run/user")
                           (type "tmpfs")
                           (check? #f)
                           (flags '(no-suid no-dev no-exec))
                           (options "mode=0755")
                           (create-mount-point? #t)
                           )
                         (file-system
                           (device "cgroup")
                           (mount-point "/sys/fs/cgroup/hugetlb")
                           (type "cgroup")
                           (check? #f)
                           (options "hugetlb")
                           (create-mount-point? #t)
                           (dependencies (list (car %control-groups)))
                           )
                         (file-system
                           (device "cgroup")
                           (mount-point "/sys/fs/cgroup/net_cls")
                           (type "cgroup")
                           (check? #f)
                           (options "net_cls")
                           (create-mount-point? #t)
                           (dependencies (list (car %control-groups)))
                           )
                         (file-system
                           (device "cgroup")
                           (mount-point "/sys/fs/cgroup/net_prio")
                           (type "cgroup")
                           (check? #f)
                           (options "net_prio")
                           (create-mount-point? #t)
                           (dependencies (list (car %control-groups)))
                           )
                         (file-system
                           (device "cgroup")
                           (mount-point "/sys/fs/cgroup/systemd")
                           (type "cgroup")
                           (check? #f)
                           (options "none,name=systemd")
                           (create-mount-point? #t)
                           (dependencies (list (car %control-groups)))
                           )
                         ) %control-groups ))
